from dataclasses import dataclass
from typing import List

from monkey_island.cc.database import mongo
from monkey_island.cc.services.node import NodeService


@dataclass
class ManualExploitation:
    hostname: str
    ip_addresses: List[str]
    start_time: str


def get_manual_exploitations() -> List[ManualExploitation]:
    monkeys = get_manual_monkeys()
    return [monkey_to_manual_exploitation(monkey) for monkey in monkeys]


def get_manual_monkeys():
    return [
        monkey for monkey in mongo.db.monkey.find({}) if NodeService.get_monkey_manual_run(monkey)
    ]


def monkey_to_manual_exploitation(monkey: dict) -> ManualExploitation:
    return ManualExploitation(
        hostname=monkey["hostname"],
        ip_addresses=monkey["ip_addresses"],
        start_time=monkey["launch_time"],
    )
