from dataclasses import dataclass
from enum import Enum
from typing import List, Union


class CredentialType(Enum):
    PASSWORD = "password"
    HASH = "hash"
    KEY = "key"


@dataclass
class ExploiterReportInfo:
    machine: str
    ip_address: str
    type: str
    username: Union[str, None] = None
    credential_type: Union[CredentialType, None] = None
    ssh_key: Union[str, None] = None
    password: Union[str, None] = None
    port: Union[str, None] = None
    paths: Union[List[str], None] = None
    password_restored: Union[bool, None] = None
    service: Union[str, None] = None
