from monkey_island.cc.services.node import NodeService
from monkey_island.cc.services.reporting.issue_processing.exploit_processing.exploiter_report_info import (  # noqa: E501
    ExploiterReportInfo,
)


class Log4ShellProcessor:
    @staticmethod
    def get_exploit_info_by_dict(class_name: str, exploit_dict: dict) -> ExploiterReportInfo:
        ip_addr = exploit_dict["data"]["machine"]["ip_addr"]
        machine = NodeService.get_node_hostname(NodeService.get_node_or_monkey_by_ip(ip_addr))
        port = exploit_dict["data"]["info"]["vulnerable_service"]["port"]
        service = exploit_dict["data"]["info"]["vulnerable_service"]["service_name"]
        return ExploiterReportInfo(
            ip_address=ip_addr, machine=machine, type=class_name, port=port, service=service
        )
